#ifndef DETECTPLATE_H_
#define DETECTPLATE_H_

#include "common.h"
#include "adacascadeclass.h"

/**
 * Classify source image pixels according to cluster_means_norm matrix.
 *
 * Return a pair of matrices of the same size as source_image
 * 1st - .first  - timg
 * 2nd - .second - wimg
 */
std::pair<CvMat*, CvMat*> ClassifyImagePixels( CvMat * source_image,
                                               CvMat * cluster_means_norm,
                                               PixClass pixclass );

CvMat ** IntegralBlockHist( CvMat * timg,
                            CvMat * wimg,
                            size_t cluster_number,
                            size_t dx, size_t dy );

typedef std::vector<SubWindowInfo> SubWindows;

IMPEXP
SubWindows DetectPlate( CvMat * cource,
                        Model const & model, 
                        CvMat * cluster_means,
                        CvMat * cov_matrix,
                        CvMat * cluster_means_norm );

void ClearModelCache(Model const & model);

#endif
