#include "stdafx.h"
#include "dump.h"

#define IGNORE_DUMPS

void DumpMatrix( std::string const & filename, CvMat const * mat)
{
#ifndef IGNORE_DUMPS
    CvFileStorage * fs = cvOpenFileStorage( filename.c_str(), NULL, CV_STORAGE_WRITE );
    cvWrite( fs, "matrix", mat );
    cvReleaseFileStorage( &fs );
#endif
}

void DumpResultingWindows( std::string const & filename, SubWindows const & wins)
{
    (void)filename;
    (void)wins;
#ifndef IGNORE_DUMPS
    if (wins.empty())
    {
        std::cout << "No matching sub_windows...\n" << std::flush;
        return;
    }
    // 6:
    //  4 window coordinates
    //  1 dfce
    //  1 cluster_size
    CvMat * results = cvCreateMat( wins.size(), 6, CV_32F );

    uint count = 0;
    for (SubWindows::const_iterator cit = wins.begin(); cit != wins.end(); ++cit)
    {
        if (++count < 10)
        {
            std::cout << ">> matching window (" << cit->stage << ") [" << count << "/" << wins.size() << "]("
                                                   << cit->x << ","
                                                   << cit->y << ","
                                                   << (cit->x + cit->w) << ","
                                                   << (cit->y + cit->h) << ";" << cit->cluster_size << ")\n" << std::flush;
        }
        float * f = &CV_MAT_ELEM( *results, float, cit - wins.begin(), 0 );
        *f = cit->x;
        *++f = cit->y;
        *++f = cit->w;
        *++f = cit->h;

        *++f = cit->dfce;
        *++f = cit->cluster_size;
    }

    DumpMatrix( filename, results );

    cvReleaseMat( &results );
#endif
}

