#ifndef LOCALHISTINTEGRAL_H_
#define LOCALHISTINTEGRAL_H_

#include "common.h"

//h=localhistintegral(inthist,x1,y1,ww,wh,htype,normflag)
//
//    Computes local histogram from an integral histogram 'inthist'
//    htype = {1|2|3|4} / default=1 (see code)


//h=localhistintegral(inthist,x1,y1,ww,wh,htype,normflag)
/**
 * Compute local histogram for a subwindow from an integral histogram
 * according to the 'rule.type'.
 */
void localhistintegral(StageRule const & rule,                          // <- input
                       CvMat ** integral_block_histogram,               // <- input
                       uint channels,                                   // <- input
                       uint left, uint top, uint width, uint height,    // <- input
                       std::vector<double> & feature);                  // <- output

#endif
